import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { Title, HeadProvider, Link, Meta } from 'react-head';
import Body from './Body';
import Html from './Html';
import { extractTitleFrom, extractTagsFrom, renderTags } from './utils';
var Head = function (_a) {
    var bodyAttributes = _a.bodyAttributes, children = _a.children, htmlAttributes = _a.htmlAttributes, title = _a.title, _b = _a.meta, meta = _b === void 0 ? [] : _b, _c = _a.link, link = _c === void 0 ? [] : _c;
    var metaTagsToRender = extractTagsFrom({
        children: children,
        tag: 'meta',
        fallback: meta
    });
    var linkTagsToRender = extractTagsFrom({
        children: children,
        tag: 'link',
        fallback: link
    });
    // title is a special case, so we have the extract from the array
    // and simplify the fallback as used by the method
    var titleToRender = extractTitleFrom({
        children: children,
        fallback: title
    });
    return (_jsxs(_Fragment, { children: [titleToRender !== '' && _jsx(Title, { children: titleToRender }, void 0),
            renderTags({ tagsArray: metaTagsToRender, Component: Meta }),
            renderTags({ tagsArray: linkTagsToRender, Component: Link }),
            (bodyAttributes != null) && _jsx(Body, { attributes: bodyAttributes }, void 0),
            (htmlAttributes != null) && _jsx(Html, { attributes: htmlAttributes }, void 0)] }, void 0));
};
export { HeadProvider };
export default Head;
